/*
 * cgrasp.c
 *
 *  Created on: Oct 25, 2010
 *      Author: Ricardo Martins de Abreu Silva
 */

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include "cgrasp.h"
#include <string.h>
//#include "module.h"

#if HAVE_LTDL_H
# include <ltdl.h>
#endif


//typedef double entrypoint ( double * arg);
//entrypoint * run;

        PyObject *pdict, *pName, *pModule, *pFunc, *pList, *pValue, *pArgs, *pvar, *pl, *pu;


double cost( int n, PyObject *pFunc, PyObject *pList, int *counter, int stp, int fes){

        double cost;
        PyObject *pArgs;
        PyObject *pValue;

        pArgs = PyTuple_New(1);
        Py_INCREF(pList);
        PyTuple_SetItem(pArgs, 0, pList);

        pValue = PyObject_CallObject(pFunc, pArgs);
        Py_DECREF(pArgs);

	(*counter)=(*counter)+1;

        if (stp){
//printf("CONDICAO DE PARADA, %d, %d \n", (*counter), fes);
		if ( (*counter) >= fes ){
			exit (0);
		}
	}


        if (pValue != NULL) {
                PyArg_Parse(pValue, "d", &cost);
                Py_DECREF(pValue);
                return cost;
        }else {
                Py_DECREF(pFunc);
                Py_DECREF(pList);
                PyErr_Print();
                fprintf(stderr,"Call function failed\n");
                exit;
        }

 }


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

double urand()
{
    // return drand48();
//    return (double(rand())/RAND_MAX);
    return genrand_real1()/RAND_MAX;

}


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

int urand_ind(int max_ind)
{
//    return rand()%max_ind;
//      return (int)genrand_real1()%max_ind;
        return genrand_int32()%max_ind;
}



//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void UnifRand(int n, double* l, double *u, double *x){

        int i;

        for (i=0; i<n;i++){
                (*(x+i))= (*(l+i)) + genrand_real1() * ( (*(u+i)) - (*(l+i)) );
        }

}




//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

float timer ()
{
  struct rusage r;

  getrusage(0, &r);
  return (float)(r.ru_utime.tv_sec+r.ru_utime.tv_usec/(float)1000000);
}



//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void print_solution(int n, double *x, FILE* outFile){

        int i;

        printf("\nsolution: ");
        fprintf(outFile, "\nsolution: ");
        for (i=0; i<n; i++){
                printf("%f ",*(x+i)); 
                fprintf(outFile, "%f ",*(x+i));
        }
}


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void copy_double_vector(double* dst, double* src, int sz){
        int i;
        for (i=0; i<sz; i++){
                *(dst+i)=*(src+i);
        }
}



//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void print_improvement( char * message, int n, float t2, double *x, double cost, double *x_s, double *f, FILE* outFile, int fecount){


                        printf("\n%s\n",message);
                        fprintf(outFile, "\n%s\n", message);

                        printf("time: %f\n", timer()-t2);
                        fprintf(outFile, "time: %f\n", timer()-t2);

                        printf("evaluations: %d\n", fecount);
                        fprintf(outFile, "evaluations: %d\n", fecount);

                        *f = cost;
                        printf("best value: %f ", *f);
                        fprintf(outFile, "best value: %f ", *f);

                        copy_double_vector(x_s,x,n);
                        print_solution(n,x_s,outFile);

                        printf("\n\n");
                        fprintf(outFile, "\n\n");

}


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void line_search2(int n, double h, double *l, double *u, 
                 double *x, int i, double* z_i, double* g_i, float t2, double *x_s, double f, 
                 double opt, FILE * outFile, int* count_calc_cost, int* fecount, int stp, int fes){

        int j, start, end, z;
        double x_i, c, s_domain, e_domain;



        PyObject *pValue, *pArgs;

        pArgs = PyTuple_New(1);

        x_i = *(x+i);
        s_domain = *(l+i);
        e_domain = *(u+i);

        for (z = 0; z < n; z++) {

                pValue = PyFloat_FromDouble(x[z]);

                if (!pValue) {
                        Py_DECREF(pList);
                        Py_DECREF(pArgs);
                        Py_DECREF(pFunc);
//                        fprintf(stderr, "Cannot convert argument\n");
                        exit;
                }

                PyList_SetItem(pList, z, pValue);

        }

        *g_i = cost(n, pFunc, pList, fecount, stp, fes);

        *z_i = x_i;

        start = (int)floor((x_i-s_domain)/h);

        for (j=-start; j<0; j++){

                *(x+i) = x_i+j*h;

                pValue = PyFloat_FromDouble(x[i]);

                if (!pValue) {
                        Py_DECREF(pList);
                        Py_DECREF(pArgs);
                        Py_DECREF(pFunc);
//                        fprintf(stderr, "Cannot convert argument\n");
                        exit;;
                }

                PyList_SetItem(pList, i, pValue);

                c = cost(n, pFunc, pList, fecount, stp, fes);

                if (c < *g_i){

                        *g_i = c;
                        *z_i = *(x+i);

                }

        }

        end = (int)floor( (e_domain - x_i )/h );

        for (j=1; j<end; j++){

                *(x+i) = x_i+j*h;

                pValue = PyFloat_FromDouble(x[i]);

                if (!pValue) {

                        Py_DECREF(pList);
                        Py_DECREF(pArgs);
                        Py_DECREF(pFunc);
//                        fprintf(stderr, "Cannot convert argument\n");
                        exit;
                }

                PyList_SetItem(pList, i, pValue);


                c = cost(n, pFunc, pList, fecount, stp, fes);

                if (c < *g_i){

                        *g_i = c;
                        *z_i = *(x+i);

                }
        }

//      *(x+i) = x_i;
        *(x+i) = *z_i;

        Py_DECREF(pArgs);

}


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

typedef struct{
   int i; // i-th coordinate
   double z_i; // value for the i-th coordinate that minimizes the obj. function with the other n-1 coordinates of x held at their current values
   double g_i; // objective function value for x with the i-th coordinate set to z_i
}item;

size_t mymeter(const void *el) {
    /* every element has the constant size of a item structure */
    return sizeof(item);
}

/*
 * compare items by coordinates
 *
 * this function compares two coordinates from two items:
 * <0: a greater than b
 * 0: a equivalent to b
 * >0: b greater than a
 */
int mycomparator(const void *a, const void *b) {
    /* compare items */
    const item *A = (item *) a;
    const item *B = (item *) b;
    return (A->i < B->i) - (A->i > B->i);
}

/* return "match" when the contact ID matches the key */
int seeker(const void *el, const void *key) {
    /* let's assume el and key being always != NULL */
    const item *cont = (item *)el;

    if (cont->i == *(int *)key)
        return 1;
    return 0;
}

void construct_greedy_randomized(int n, double ro, double h, double *l, double *u, 
double * x, int * imprc, float t2, double *x_s, double f, double opt, FILE * outFile, int* count_calc_cost, int* fecount, int stp, int fes){

    int i, reuse;
    double alpha, g_floor, g_ceil, z_i, g_i;


    item * element;
    list_t unfixed;

    item * it_u;

    element = (item *) malloc(sizeof(item));
    list_init(&unfixed);
    list_attributes_copy(&unfixed, mymeter, 1);
    list_attributes_comparator(&unfixed, mycomparator);
    list_attributes_seeker(&unfixed, seeker);
    for (i=0; i<n; i++){
        element->i=i;
        list_append(&unfixed,element);
    }
    alpha = genrand_real1();
    reuse = 0;

        g_floor = infinity;
        g_ceil = -infinity;

        if( list_iterator_start(&unfixed) ){
            while ( list_iterator_hasnext(&unfixed) ){
                it_u = (item *) list_iterator_next(&unfixed);
                if (reuse == 0){
                        i = it_u->i;
                        line_search2(n, h, l, u, x, i, &z_i, &g_i, t2, x_s, f, opt, outFile, count_calc_cost, fecount, stp, fes);
                        it_u->z_i = z_i;
                        it_u->g_i = g_i;
                }else{
                        g_i = it_u->g_i;
                }
                if (g_floor > g_i){g_floor = g_i;}
                if (g_ceil < g_i){g_ceil = g_i;}
            }
            list_iterator_stop(&unfixed);
        }

    list_destroy(&unfixed);


}




//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void local_search_1 (int n, double ro, double h, double *l, double *u, double max_points, 
double* x, int* impr, float t2, double *x_s, double f, double opt, FILE* outFile, int* count_calc_cost, int* fecount, int stp, int fes){

        int ok, i, num_points_examined;
        double f_str, c, norm, s_domain, e_domain;

        double * y = (double *) malloc(n*sizeof(double));
        double * z = (double *) malloc(n*sizeof(double));



        PyObject *pValue, *pArgs;

        pArgs = PyTuple_New(1);

        for (i = 0; i < n; i++) {
                pValue = PyFloat_FromDouble(x[i]);
                if (!pValue) {
                        Py_DECREF(pList);
                        Py_DECREF(pFunc);
                        fprintf(stderr, "Cannot convert argument\n");
                        exit;
                }

                PyList_SetItem(pList, i, pValue);
        }
        f_str = cost(n, pFunc, pList, fecount, stp, fes);

//      num_grid_points = pow((int)floor((e_domain - s_domain)/h),n);

//      pts = floor(ro*num_grid_points);

//      if ( pts < max_points ){
//              max_points = pts;
//      }

        num_points_examined = 0;

        while ( num_points_examined <= max_points ) {

                ok = 0;
                do{
                        norm = 0.0;
                        for (i=0; i<n; i++){

                                s_domain = (*(l+i));
                                e_domain = (*(u+i));
                                if (genrand_real1() <= 0.5){
                                        *(z+i) = (double) urand_ind( (int)ceil( (e_domain - (*(x+i)) )/h ) );
                                }else{
                                        *(z+i) = (double) -1.0*urand_ind( (int)ceil( ((*(x+i))-s_domain)/h) );
                                }
                                if ( (*(z+i)) != 0){
                                        ok = 1;
                                }
                                norm = norm + pow((*(z+i))*h,2);
                        }

                }while(!ok);

                norm = sqrt(norm);

                for (i=0; i<n; i++){
                        *(y+i) = *(x+i) + (1.0/norm)*h*(*(z+i))*h;
                        pValue = PyFloat_FromDouble(y[i]);
                        if (!pValue) {
                                Py_DECREF(pList);
                                Py_DECREF(pArgs);
                                Py_DECREF(pFunc);
                                fprintf(stderr, "Cannot convert argument\n");
                                exit;
                        }
                PyList_SetItem(pList, i, pValue);

        }

        c = cost(n, pFunc, pList, fecount, stp, fes);

        if ( c < f_str ){
                copy_double_vector(x, y, n);
                f_str = c;
                num_points_examined = 0;
                *(impr)=1;
        }

        num_points_examined++;

  }
 
        free(y);
        free(z);

      Py_DECREF(pArgs);

}


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

double cgrasp(int agc, char **agv)
{

	char * outfilename, * prefix;
	char ov[]="-ov", it[]="-it", fe[]="-fe";
	int i, n, count_calc_cost, imprc, imprl, ls_opt, size, iterations, function_evaluations, count, countin, loop, fecount=0, stp=0;
	long seed;
	double opt, h_s, h_e, ro, max_points, ep, cost_x, h, f_star, threshold, *x, *x_star, *best_solution, *l, *u;
	float t2;
//	PyObject *pdict, *pName, *pModule, *pFunc, *pList, *pValue, *pArgs, *pvar, *pl, *pu;
	FILE *outFile;

	Py_Initialize();

	//--- verifying input file correcteness ----------------------
	pName = PyString_FromString("cgrasparser");
        pModule = PyImport_Import(pName);
if (pModule==NULL) printf("pModule null\n");
        Py_DECREF(pName);
	pFunc = PyObject_GetAttrString(pModule, "verifying");
if (pFunc==NULL) printf("pFunc null\n");
	Py_DECREF(pModule);
	pArgs = PyTuple_New(1);
	PyTuple_SetItem(pArgs, 0, PyString_FromString(agv[1]) );
	pValue = PyObject_CallObject(pFunc, pArgs);
	Py_DECREF(pArgs);
	Py_DECREF(pFunc);
	//------------------------------------------------------------
	if (pValue != NULL){

		//--- updating data structures -----------------------------------
		n = atoi( PyString_AsString( PyList_GetItem( pValue, 2)));
		x = (double *) malloc (n*sizeof(double));
		x_star = (double *) malloc (n*sizeof(double));
		best_solution = (double *) malloc (n*sizeof(double));

		PyArg_Parse( PyList_GetItem( pValue, 3), "i", &size);
		l = (double *) malloc (size*sizeof(double));
		u = (double *) malloc (size*sizeof(double));

                pl = PyList_GetItem( pValue, 4);
		pu = PyList_GetItem( pValue, 5);

                for (i=0; i< size; i++){
			PyArg_Parse(PyList_GetItem( pl, i), "d", &l[i]);
                        PyArg_Parse(PyList_GetItem( pu, i), "d", &u[i]);
		}

		prefix = PyString_AsString( PyList_GetItem( pValue, 6));
//printf("PASSEI AQUI -1 %s\n",prefix);
		if ( !strcmp(prefix,ov) ){
//printf("PASSEI AQUI 0\n");
	                opt = atof( PyString_AsString( PyList_GetItem( pValue, 7)));
		}else{
			if ( !strcmp(prefix,it) ){
				iterations = atoi( PyString_AsString( PyList_GetItem( pValue, 7)));
printf("iterations %d\n", iterations);
			}else{
	                        if ( !strcmp(prefix,fe) ){
	                                function_evaluations = atoi( PyString_AsString( PyList_GetItem( pValue, 7)));
printf("function evaluations %d\n", function_evaluations);
				}
			}
		}
                seed = atol( PyString_AsString( PyList_GetItem( pValue, 8)));
                ep = atof( PyString_AsString( PyList_GetItem( pValue, 9)));
                h_s = atof( PyString_AsString( PyList_GetItem( pValue, 10)));
                h_e = atof( PyString_AsString( PyList_GetItem( pValue, 11)));
                ro = atof( PyString_AsString( PyList_GetItem( pValue, 12)));
                ls_opt = atoi( PyString_AsString( PyList_GetItem( pValue, 13)));
                max_points = atof( PyString_AsString( PyList_GetItem(pValue,14)));
		outfilename = PyString_AsString( PyList_GetItem( pValue, 15));
		outFile=fopen(outfilename,"w");

//                printf("optimum: %lf\n", opt);
                printf("dimension: %d\n", n);
                printf("epsilon: %lf\n", ep);
                printf("seed: %lu\n", seed);
                printf("h_s: %lf\n", h_s);
                printf("h_e: %lf\n", h_e);
                printf("ro: %lf\n", ro);
                printf("LS option: %d\n", ls_opt);
                printf("LS max points: %lf\n", max_points);

	        //--- creating output file ---------------------------------------
        	if ( outFile ==NULL ){
                	printf("ERROR ALLOCATING OUTPUT FILE\n");
                	exit;
        	}

		count_calc_cost=0;

		pName = PyString_FromString( PyString_AsString( PyList_GetItem( pValue ,0 ) ) );
		pModule = PyImport_Import(pName);
		Py_DECREF(pName);

		pFunc = PyObject_GetAttrString( pModule, PyString_AsString( PyList_GetItem( pValue, 1 ) ) );
		Py_DECREF(pModule);

		pList = PyList_New(n);

		init_genrand(seed);

		t2 = timer();
                f_star = infinity;
		count = 0;
//printf("PASSEI AQUI 1\n");
		if ( !strcmp(prefix,ov) ){
//printf("PASSEI AQUI 2\n");
			if (opt==0.0 ){
				threshold = ep;
			}else{
				threshold = ep*fabs(opt);
			}

			if ( fabs( f_star - opt ) > threshold ){
				loop=1;
			}

		}else{
			if ( !strcmp(prefix,it) ){

				if ( count < iterations ){
					loop=1;
				}else{
					loop=0;
				}

			}else{
				stp = 1;
				if ( fecount < function_evaluations ){
					loop=1;
				}else{
					loop=0;
				}

			}
		}

//		while( fabs( f_star - opt ) > threshold){
//printf("PASSEI AQUI 3\n");
		while (loop){
//printf("PASSEI AQUI 4\n");
			UnifRand(n,l,u,x);
			h=h_s;

//---------------------------------------------------------------------
//			cost_x = CalculateTotalCost(x,fnt,n,mm,bt, t2, x_star, f_star, opt, outFile, &count_calc_cost);
			for (i = 0; i < n; i++) {
				pValue = PyFloat_FromDouble(x[i]);
				if (!pValue) {
					Py_DECREF(pList);
					Py_DECREF(pFunc);
					fprintf(stderr, "Cannot convert argument\n");
					exit;
				}
				PyList_SetItem(pList, i, pValue);
			}
			cost_x = cost(n, pFunc, pList, &fecount, stp, function_evaluations);
//----------------------------------------------------------------------

			if (cost_x < f_star){
printf("\nh=%f, h_e=%f", h, h_e);
fprintf(outFile, "\nh=%f, h_e=%f", h, h_e);

				printf("\no-iteration: %d ", count);
				fprintf(outFile, "\no-iteration: %d ", count);
                                printf("\ni-iteration: %d ", countin);
                                fprintf(outFile, "\ni-iteration: %d ", countin);


				print_improvement( "random: ", n, t2, x, cost_x, x_star, &f_star, outFile, fecount);
				if (!strcmp(prefix,ov)){
					if (fabs( f_star - opt ) <= threshold) {
						break;
					}else{
						loop=1;
					}
//				}else{
				}

//				}
			}
printf("\nh=%f, h_e=%f", h, h_e);
fprintf(outFile, "\nh=%f, h_e=%f", h, h_e);
			countin=0;
			while (h>=h_e){

				countin++;
				imprc = 0;
				imprl = 0;

                		construct_greedy_randomized(n,ro,h,l,u,x,&imprc,t2, x_star, f_star, opt, outFile, &count_calc_cost, &fecount, stp, function_evaluations);


//---------------------------------------------------------------------
//      	cost_x = CalculateTotalCost(x,fnt,n,mm,bt, t2, x_star, f_star, opt, outFile, &count_calc_cost);
        			for (i = 0; i < n; i++) {
                			pValue = PyFloat_FromDouble(x[i]);
                			if (!pValue) {
                        			Py_DECREF(pList);
                        			Py_DECREF(pFunc);
                        			fprintf(stderr, "Cannot convert argument\n");
                        			exit;
                			}
                			PyList_SetItem(pList, i, pValue);
        			}
        			cost_x = cost(n, pFunc, pList, &fecount, stp, function_evaluations);
//----------------------------------------------------------------------

                		if (cost_x < f_star){
printf("\nh=%f, h_e=%f", h, h_e);
fprintf(outFile, "\nh=%f, h_e=%f", h, h_e);

					printf("\no-iteration: %d ", count);
					fprintf(outFile, "\no-iteration: %d ", count);
                                        printf("\ni-iteration: %d ", countin);
                                        fprintf(outFile, "\ni-iteration: %d ", countin);


                        		print_improvement( "construction: ", n, t2, x, cost_x, x_star, &f_star, outFile, fecount);
					if (!strcmp(prefix,ov)){
                        			if (fabs( f_star - opt ) <= threshold) {
							break;
						}else{
							loop=1;
						}
//					}else{
					}
//	                                }

                		}
				ls_opt =1;
                		switch(ls_opt){               

                       			case 0: //without local search                

                                        	break;   

                       			case 1: //local search: h_fixe, grid

                                        	local_search_1 (n, ro, h, l, u, max_points, x, &imprl,
                                                        t2, x_star, f_star, opt, outFile, &count_calc_cost, &fecount, stp, function_evaluations);


                                        	break;   
/*
                       		case 2: //local search: h_fixe, no grid

                                        local_search_2 (n, mm, (int) bt, fnt, ro, h, s_domain, e_domain, max_points, x, &imprl,
                                                        t2, x_star, f_star, opt, outFile, &count_calc_cost);

                                        break;      

                       		case 3: //local search: no h_fixe, grid

                                        local_search_3 (n, mm, (int) bt, fnt, ro, h_s, h_e, s_domain, e_domain, max_points, x, &imprl,
                                                        t2, x_star, f_star, opt, outFile, &count_calc_cost);

                                        break;

                       		case 4: //local search: no h_fixe, no grid

                                        local_search_4 (n, mm, (int) bt, fnt, ro, h_s, h_e, s_domain, e_domain, max_points, x, &imprl,
                                                        t2, x_star, f_star, opt, outFile, &count_calc_cost);

                                        break;
*/
                		}


//---------------------------------------------------------------------
//              	cost_x = CalculateTotalCost(x,fnt,n,mm,bt, t2, x_star, f_star, opt, outFile, &count_calc_cost);
                		for (i = 0; i < n; i++) {
                        		pValue = PyFloat_FromDouble(x[i]);
                        		if (!pValue) {
                                		Py_DECREF(pList);
                                		Py_DECREF(pFunc);
                                		fprintf(stderr, "Cannot convert argument\n");
                                		exit;
                        		}
                        		PyList_SetItem(pList, i, pValue);
                		}
                		cost_x = cost(n, pFunc, pList, &fecount, stp, function_evaluations);
//----------------------------------------------------------------------

                		if (cost_x < f_star){
printf("\nh=%f, h_e=%f", h, h_e);
fprintf(outFile, "\nh=%f, h_e=%f", h, h_e);

					printf("\no-iteration: %d ", count);
					fprintf(outFile, "\no-iteration: %d ", count);
                                        printf("\ni-iteration: %d ", countin);
                                        fprintf(outFile, "\ni-iteration: %d ", countin);


                        		print_improvement( "local search: ", n, t2, x, cost_x, x_star, &f_star, outFile, fecount);
					if (!strcmp(prefix,ov)){
                        			if (fabs( f_star - opt ) <= threshold){ 
							break;
						}else{
							loop=1;
						}
//					}else{
					}
//                                        	printf("iteration: %d ", count);
//                                        	fprintf(outFile, "iteration: %d ", count);

//                                	}


                		}

				if ( (imprc==0) && (imprl==0) ){
					h=h/2.0;
				}

			}


			count++;
	                if (!strcmp(prefix,it)){

	                        if ( count < iterations ){
                	                loop=1;
        	                }else{
					loop=0;
				}

	                }else{

	                        if (!strcmp(prefix,fe)){

//printf("******fecount: %d function_evaluations %d\n", fecount, function_evaluations);
                	                if ( fecount < function_evaluations ){
                        	                loop=1;
                                	}else{
                                        	loop=0;
                                	}

				}else{

	                        	if ( fabs( f_star - opt ) > threshold ){
                	                	loop=1;
        	                	}else{loop=0;}

				}

			}




    		}

    		printf("time: %f\n", timer()-t2);
    		fprintf(outFile, "time: %f\n", timer()-t2);
//    		printf("optimum: %lf\n", opt);
//    		fprintf(outFile,"optimum: %lf\n", opt);
    		fprintf(outFile,"dimension: %d\n", n);
    		fprintf(outFile,"epsilon: %lf\n", ep);
    		fprintf(outFile,"seed: %lu\n", seed);
    		fprintf(outFile,"h_s: %lf\n", h_s);
    		fprintf(outFile,"h_e: %lf\n", h_e);
    		fprintf(outFile,"ro: %lf\n", ro);
    		fprintf(outFile,"LS option: %d\n", ls_opt);
    		fprintf(outFile,"LS max points: %lf\n", max_points);
//    		fprintf(outFile,"output file: %s\n", agv[16]);
                fprintf(outFile,"output file: %s\n", outfilename);

    		fclose(outFile);
    		free(x);
    		free(x_star);
    		free(best_solution);
    		Py_XDECREF(pFunc);
    		Py_XDECREF(pList);
    		Py_Finalize();

return (f_star);


	}

}
