#
# cgrasparser.py
#
# Created on: Oct 31, 2010
#      Author: Ricardo Martins de Abreu Silva
#

import sys, re
from pyparsing import *

def verifying(filename):

	#reading the specification file in string text
	fp = open(filename)
	text = fp.read()
	fp.close()

	#basic patterns
	digseq = Word(nums) #sequence of digits
#	number = Combine( Optional( Literal("-") ) + digseq + Optional( Literal(".") + digseq )) 
	number = Regex(r"[+-]?(\d+(\.\d*)?|\.\d+)([Ee][+-]?\d+)?")

	bounds = number + number
	prefix = Combine( digseq + Optional( Literal(":") + digseq ), adjacent=False)

	word = Word(alphanums)
	ext = Word(alphanums,max=3)
	filename = Combine( word + Optional( Literal(".") + ext ) )
        optimal = Literal("-ov").setResultsName("prefix") + number.setResultsName("stp")
        iterations = Literal("-it").setResultsName("prefix") + digseq.setResultsName("stp")
	fevaluations = Literal("-fe").setResultsName("prefix") + digseq.setResultsName("stp")

	#directives
	module = Literal("-md") + word.setResultsName("mod")
	function = Literal("-ft") + word.setResultsName("fnt")
	dimension = Literal("-ds") + digseq.setResultsName("n")
	domain = Literal("-dm") + bounds.setResultsName("default") + Optional( ZeroOrMore( Group( prefix + bounds ) ) ).setResultsName("exception")
	stopping = optimal | iterations | fevaluations
	seed = Literal("-sd") + digseq.setResultsName("seed")
	epsilon = Literal("-ep") + number.setResultsName("ep")
	hstart = Literal("-hs") + number.setResultsName("h_s")
	hend = Literal("-he") + number.setResultsName("h_e")
	ro = Literal("-ro") + number.setResultsName("ro")
	localsearch = Literal("-ls") + digseq.setResultsName("ls_opt")
	maxiteration = Literal("-mp") + digseq.setResultsName("max_points")
	outputfile = Literal("-of") + filename.setResultsName("outfile")

	#pattern for input file
	command = Each([ module, function, dimension, domain, stopping, seed, epsilon, 
			 hstart, hend, ro, localsearch, maxiteration, outputfile])

	#list of parameters
	plist = command.parseString(text)

	if len(plist)!=0:

                deflist = plist.default.asList()
                lower = float(deflist[0])
                upper = float(deflist[1])
		key = 0

		if (lower <= upper):

			n = int(plist.n)
			llist = [lower]*n
			ulist = [upper]*n

			if plist.exception!=None:
	                        elist = plist.exception.asList()
				for ilu in elist:

					l = float(ilu[1])
					u = float(ilu[2])

					if l<=u:

						i = ilu[0].split(':')
						start = int(i[0])
						if len(i) == 2:
							end = int(i[1])
						else:
							end = start

						if start <= end:

							if start > key:

								if end < n:

									key = end

									for d in range(start,end+1):

										llist[d]=l
										ulist[d]=u

								else:
									print "In: ",ilu[0]," ",l," ",u,", ",end," >= ",n
									return None

							else:
								print "In: ",ilu[0]," ",l," ",u,", ",start," <= ",key
								return None

						else:
							print "In: ",ilu[0]," ",l," ",u,", ",start," > ",end
							return None

					else:
						print "In: ",ilu[0]," ",l," ",u,", ",l," > ",u
						return None

				resultlist = [plist.mod, plist.fnt, plist.n, len(llist), llist, ulist, plist.prefix, plist.stp, 
			      		plist.seed, plist.ep, plist.h_s, plist.h_e, plist.ro, 
			      		plist.ls_opt, plist.max_points, plist.outfile]
			
				return resultlist
			
		else:
			print "In: ",ilu[0]," ",l," ",u,", ",lower," > ",upper
			return None

	else:
		print "error"
		return None

